unit Unit5;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm5 = class(TForm)
    RadioGroup1: TRadioGroup;
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    SaveDialog1: TSaveDialog;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form5: TForm5;

ifile, ofile    :TEXT;

implementation

{$R *.DFM}

function GetData(str1 :String; Str2 :String):String;
var
locs,
retstr  :String;
Begin
   retstr:='';
   if(Pos(',',Str1) = LastDelimiter(',',Str1)) then
// pad / via
      begin
         locs:=copy(str1,Pos('(',str1)+1,Pos(',',str1)-pos('(',str1)-1);
         retstr:=retstr+'FA'+chr(13)+chr(10)+locs+' ';
         locs:=copy(str1,Pos(',',str1)+1,Pos(')',str1)-pos(',',str1)-1);
         retstr:=retstr+locs+' 50 15 30 12'+chr(13)+chr(10);
//         Showmessage('via'+retstr);
      end
   else
// track
      begin
         str1:=copy(str1,Pos('(',Str1)+1,1000);
         locs:=copy(str1,1,Pos(',',str1)-1)+' ';
         locs:=locs+copy(str1,Pos(',',str1)+1,Pos(' ',str1)-pos(',',str1)-1);
         retstr:=retstr+'FT'+chr(13)+chr(10)+locs+' ';

         str1:=copy(str1,Pos(' ',Str1),1000);
         Str1:=Trimleft(Str1);
         locs:=copy(str1,1,Pos(',',str1)-1)+' ';
         locs:=locs+copy(str1,Pos(',',str1)+1,Pos(')',str1)-pos(',',str1)-1);
         retstr:=retstr+locs+' 30 12 1'+chr(13)+chr(10);
//         Showmessage('track'+retstr);
      end;

Str1:=Str2;
   if(Pos(',',Str1) = LastDelimiter(',',Str1)) then
// pad / via
      begin
         locs:=copy(str1,Pos('(',str1)+1,Pos(',',str1)-pos('(',str1)-1);
         retstr:=retstr+'FA'+chr(13)+chr(10)+locs+' ';
         locs:=copy(str1,Pos(',',str1)+1,Pos(')',str1)-pos(',',str1)-1);
         retstr:=retstr+locs+' 50 15 30 12'+chr(13)+chr(10);
//         Showmessage('via'+retstr);
      end
   else
// track
      begin
         str1:=copy(str1,Pos('(',Str1)+1,1000);
         locs:=copy(str1,1,Pos(',',str1)-1)+' ';
         locs:=locs+copy(str1,Pos(',',str1)+1,Pos(' ',str1)-pos(',',str1)-1);
         retstr:=retstr+'FT'+chr(13)+chr(10)+locs+' ';

         str1:=copy(str1,Pos(' ',Str1),1000);
         Str1:=Trimleft(Str1);
         locs:=copy(str1,1,Pos(',',str1)-1)+' ';
         locs:=locs+copy(str1,Pos(',',str1)+1,Pos(')',str1)-pos(',',str1)-1);
         retstr:=retstr+locs+' 30 12 1'+chr(13)+chr(10);
//         Showmessage('track'+retstr);
      end;

   GetData:=RetStr;
//   showmessage(retstr);

end;


procedure TForm5.Button1Click(Sender: TObject);
var
outstr,
locs,
locs1,
locs2           :String;
databuf         :Array [0..999999] of char;
SizeOfFile      :Integer;
bifile, bofile  :file;
begin
   OpenDialog1.title:='Select DRC file';
   Opendialog1.filterindex := 1;
   If(OpenDialog1.execute = False) then Exit;
   assignfile(ifile,OpenDialog1.filename);
   reset(ifile);
   outstr:='';
   while(NOT(EOF(ifile))) do
      begin
         readln(ifile,locs);
         if(pos('Clearance Error',locs)=01) then
            begin
               readln(ifile,locs1);
               readln(ifile,locs2);
               outstr:=outstr+GetData(locs1,locs2);
//               showmessage(locs+locs1+locs2);
            end;

      end;
  closefile(ifile);
//outstr is a group of PCB primatives
// They can be written to an independant file
// Added to the working file
// Or appended to a new PCB file.
// Write "block" file
   if(RadioGroup1.itemindex = 0) then
      begin
         outstr:='PCB FILE 4'+Chr(13)+Chr(10)+OutStr;
         outstr:=outstr+'ENDPCB'+Chr(13)+chr(10);
         if(savedialog1.execute=false) then exit;
         assignfile(ofile,savedialog1.filename);
         rewrite(ofile);
         write(ofile,outstr);
         closefile(ofile);
         showmessage('Done');
      end;

// Create new pcb file
   if(RadioGroup1.itemindex = 1) then
      begin
         outstr:=outstr+'ENDPCB'+Chr(13)+chr(10);
         OpenDialog1.title:='Select PCB file';
         Opendialog1.filterindex := 2;
         If(OpenDialog1.execute = False) then Exit;
         assignfile(bifile,OpenDialog1.filename);
         reset(bifile,1);
         blockread(bifile, databuf, SizeOf(databuf), SizeOfFile);
         closefile(bifile);
         if(savedialog1.execute=false) then exit;
         assignfile(bofile,savedialog1.filename);
         rewrite(bofile,1);
         blockwrite(bofile,databuf,SizeOfFile-8);
         closefile(bofile);
         assignfile(ofile,savedialog1.filename);
         append(ofile);
         write(ofile,outstr);
         closefile(ofile);
         showmessage('Done');
      end;


end;


end.
